data Bboom = Blad Int
           | Splits Bboom Bboom

data Lijst a = Nil
             | Cons a (Lijst a)

data PolyBoom a = Leaf a
                | Branch (PolyBoom a) (PolyBoom a)

data Richting = Noord | Oost | Zuid | West

data MayBe a = No | Yes a

data MultiBoom a = Node a [MultiBoom a]

data Inpak a = Verpak a

data Raar a b = Een (a,b) (a->b) Int
	              | Twee [a] [(a,b)] (MayBe a)
	              | Drie (Raar a b) (Raar a b)
	              | Vier [(Raar a b)]
	              | Vijf (a, Raar a b)
	              | Zes (Raar b a)
	              | Zeven (a -> (Raar a b))

data HaskellType = HVariable String
                 | HConstructor String [HaskellType]
                 | HTypeConstructor String
                 | HList HaskellType
                 | HFunction HaskellType HaskellType
                 | HTupel [HaskellType]
                 | HData HaskellType [HaskellType]
                 | HTypeApplication HaskellType HaskellType
